<template>
  <!-- <AbsoluteLayout @loaded="appLoaded"  ref="rootLayout" height="100%" width="100%"> -->
    
    <!-- <StackLayout left="0" top="0" height="100%" width="100%" class="backdrop" :class="classBackdrop" /> -->
    <AbsoluteLayout @loaded="appLoaded" ref="fabItemPosition" height="100%" width="100%">
      <GridLayout height="300" ref="fabItemContainer" left="8" top="8" marginTop="50%" marginLeft="80%">
        <FabItem 
          marginTop="50%"
          @tapped="toggleAddEvent"
          row="1" 
          iconset="fas" 
          :class="classItem1" 
          color="#E94E77" 
          title="fa-plus"  
        />
        <FabItem 
          marginTop="50%"
          @tapped="toggleSearch"
          row="2" 
          iconset="fas"  
          :class="classItem2" 
          color="#3FB8AF" 
          title="fa-search" 
        />
        
        <FabItem 
          marginTop="50%"
          @tapped="centerUserLocation" 
          row="3" 
          iconset="fas" 
          :class="classItem3" 
          color="#FCB653" 
          title="fa-location-arrow" 
        />
      </GridLayout>
      <FabButton marginTop="85%" marginLeft="80%" class="fab-button" @fabTapped="fabTapped" :isActive="isActive" />

    </AbsoluteLayout>
    
  <!-- </AbsoluteLayout> -->

</template>

<script>

  const app = require('tns-core-modules/application')
  const platform = require('tns-core-modules/platform')
  
  import FabButton from '@/components/FabButton'
  import FabItem from '@/components/FabItem'

  export default {
    components: { FabButton, FabItem,},
    data: () => ({
      isActive: false
    }),
    computed: {
      classItem1() {
          return this.isActive ? "raiseItem1" : "downItem1"
      },
      classItem2() {
          return this.isActive ? "raiseItem2" : "downItem2"
      },
      classItem3() {
          return this.isActive ? "raiseItem3" : "downItem3"
      },            
      classBackdrop() {
          return this.isActive ? "backdrop-visible" : "backdrop-invisible"
      }
    },
    methods: {
      tapButton() {
        console.log('hello there ive been tapped')
      },
      appLoaded(args) {

				let fabItemContainer = this.$refs.fabItemContainer.nativeView
				let fabItemPosition = this.$refs.fabItemPosition.nativeView
				// let rootLayout = this.$refs.rootLayout.nativeView

				// Needed to avoid masking child components on Android
				if (app.android && platform.device.sdkVersion >= '21') {
					// fabItemContainer.android.setClipChildren(false)
					// fabItemPosition.android.setClipChildren(false)
					// rootLayout.android.setClipChildren(false)
				}				 
      },
      fabTapped() {
        this.isActive = !this.isActive
      },
      closeFabMenu() {
        if (this.isActive) {
          this.isActive = false
        }
      },
      centerUserLocation() {
        this.$emit('centerUserLocation')
        this.closeFabMenu()
      },
      toggleSearch() {
        this.$emit('toggleSearch')
        this.closeFabMenu()
      },
      toggleAddEvent(){
        this.$emit('toggleAddEvent')
        this.closeFabMenu()
      }
    }
  }
</script>

<style scoped>
  .backdrop {
		background-color: rgba(29, 30, 35, .90);
		opacity: 0;
	}

	/* .backdrop-visible {
		animation-name: activateBackdrop;
		animation-duration: .25;
		animation-fill-mode: forwards;
	}

	.backdrop-invisible {
		animation-name: activateBackdrop;
		animation-duration: .25;
		animation-fill-mode: forwards;
		animation-direction: reverse;
	} */

	.raiseItem1 {
		opacity: 1;
		animation-name: raiseItem1;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.raiseItem2 {
		opacity: 1;
		animation-name: raiseItem2;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.raiseItem3 {
		opacity: 1;
		animation-name: raiseItem3;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.downItem1 {
		animation-name: raiseItem1;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.downItem2 {
		animation-name: raiseItem2;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	.downItem3 {
		animation-name: raiseItem3;
		animation-duration: .20;
		animation-timing-function: cubic-bezier(0.895, 0.030, 0.685, 0.220);
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	@keyframes activateBackdrop {
		from {
			opacity: 0;
		}
		to {
			opacity: 1;
		}
	}

	@keyframes raiseItem1 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translate(0, -64);
		}
	}

	@keyframes raiseItem2 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translate(0, -128);
		}
	}

	@keyframes raiseItem3 {
		from {
			opacity: 1;
			transform: translate(0, 0);
		}
		to {
			opacity: 1;
			transform: translate(0, -192);
		}
	}
</style>